##################################################
#
# go backend build
FROM openshift/golang-builder:1.10 AS gobuilder
ENV __doozer=update BUILD_RELEASE=3 BUILD_VERSION=v3.11.232 OS_GIT_MAJOR=3 OS_GIT_MINOR=11 OS_GIT_PATCH=232 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=3.11.232-3 
ENV __doozer=merge OS_GIT_COMMIT=6d56159 OS_GIT_VERSION=3.11.232-2-6d56159 SOURCE_DATE_EPOCH=1573666736 SOURCE_GIT_COMMIT=6d56159958caf7102529458cf38775d33d19e9ad SOURCE_GIT_TAG=6d561599 SOURCE_GIT_URL=https://github.com/openshift/console 
RUN mkdir -p /go/src/github.com/openshift/console/
ADD . /go/src/github.com/openshift/console/
WORKDIR /go/src/github.com/openshift/console/
RUN ./build-backend.sh


##################################################
#
# nodejs frontend build
FROM rhscl/nodejs-8-rhel7:1 AS nodebuilder
ENV __doozer=update BUILD_RELEASE=3 BUILD_VERSION=v3.11.232 OS_GIT_MAJOR=3 OS_GIT_MINOR=11 OS_GIT_PATCH=232 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=3.11.232-3 
ENV __doozer=merge OS_GIT_COMMIT=6d56159 OS_GIT_VERSION=3.11.232-2-6d56159 SOURCE_DATE_EPOCH=1573666736 SOURCE_GIT_COMMIT=6d56159958caf7102529458cf38775d33d19e9ad SOURCE_GIT_TAG=6d561599 SOURCE_GIT_URL=https://github.com/openshift/console 

ADD . .

USER 0
# extract the yarn dependencies that must be provided in the dist-git lookaside cache
RUN tar fx yarn-offline.tar

# bootstrap yarn so we can install and run the other tools.
RUN container-entrypoint npm install ./yarn-1.9.4.tgz

# prevent download of chromedriver, sass binary, and node headers as part of module installs
ENV CHROMEDRIVER_SKIP_DOWNLOAD=true \
    SKIP_SASS_BINARY_DOWNLOAD_FOR_CI=true \
    NPM_CONFIG_TARBALL=$HOME/node-v8.9.4-headers.tar.gz

# run the build
RUN container-entrypoint ./build-frontend.sh


##################################################
#
# actual base image for final product
FROM openshift3/ose-base:v3.11.232.20200610.203339
ENV __doozer=update BUILD_RELEASE=3 BUILD_VERSION=v3.11.232 OS_GIT_MAJOR=3 OS_GIT_MINOR=11 OS_GIT_PATCH=232 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=3.11.232-3 
ENV __doozer=merge OS_GIT_COMMIT=6d56159 SOURCE_DATE_EPOCH=1573666736 SOURCE_GIT_COMMIT=6d56159958caf7102529458cf38775d33d19e9ad SOURCE_GIT_TAG=6d561599 SOURCE_GIT_URL=https://github.com/openshift/console
RUN mkdir -p /opt/bridge/bin
COPY --from=gobuilder /go/src/github.com/openshift/console/bin/bridge /opt/bridge/bin
COPY --from=nodebuilder /opt/app-root/src/frontend/public/dist /opt/bridge/static

WORKDIR /
# doesn't require a root user.
USER 1001

CMD [ "/opt/bridge/bin/bridge", "--public-dir=/opt/bridge/static" ]

LABEL \
        io.k8s.description="This is a component of OpenShift Container Platform and provides a web console." \
        com.redhat.component="openshift-enterprise-console-container" \
        maintainer="Samuel Padgett <spadgett@redhat.com>" \
        name="openshift3/ose-console" \
        License="GPLv2+" \
        io.k8s.display-name="OpenShift Console" \
        vendor="Red Hat" \
        io.openshift.tags="openshift,console" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        io.openshift.maintainer.component="Management Console" \
        version="v3.11.232" \
        release="3" \
        io.openshift.build.commit.id="6d56159958caf7102529458cf38775d33d19e9ad" \
        io.openshift.build.source-location="https://github.com/openshift/console" \
        io.openshift.build.commit.url="https://github.com/openshift/console/commit/6d56159958caf7102529458cf38775d33d19e9ad"

